﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using AjaxControlToolkit;
using System.Drawing;

namespace AJAXAccordeon
{
    [DefaultProperty("Text")]
    [ToolboxData("<{0}:WebCustomControlAjaxAccordeon runat=server></{0}:WebCustomControlAjaxAccordeon>")]
    public class WebCustomControlAjaxAccordeon : Accordion
    {
        private Panel _panel1;

        private Panel _panel2;

        public Label hourLabel;

        public WebCustomControlAjaxAccordeon()
        {
            _panel1 = new Panel();
            hourLabel = new Label();
            this.ID = "AjaxAccordeon1";
            this.FadeTransitions = true;
            
        }
        [Bindable(true)]
        [Category("Appearance")]
        [DefaultValue("")]
        [Localizable(true)]
        public string Text
        {
            get
            {
                String s = (String)ViewState["Text"];
                return ((s == null) ? String.Empty : s);
            }

            set
            {
                ViewState["Text"] = value;
            }
        }

        protected override void RenderContents(HtmlTextWriter output)
        {
            output.Write(Text);
        }

        protected override void CreateChildControls()
        {

            _panel1.Controls.Add(hourLabel);
            hourLabel.Text = DateTime.Now.TimeOfDay.ToString();
            AccordionPane ap1 = new AccordionPane();
            ap1.HeaderContainer.Controls.Add(new LiteralControl("Premier Panel"));
            ap1.ContentContainer.Controls.Add(new LiteralControl("Contenu du Premier Panel."));

            ap1.ContentContainer.Controls.Add(_panel1);
            AccordionPane ap2 = new AccordionPane();
            ap2.HeaderContainer.Controls.Add(new LiteralControl("Second Panel"));
            ap2.ContentContainer.Controls.Add(new LiteralControl("Contenu du Second Panel"));
            this.Panes.Add(ap1);
            this.Panes.Add(ap2);

            this.BorderStyle = BorderStyle.Double;
            //ajout de l'accordeon aux controles enfants du WebControl.

            base.CreateChildControls();
        }

        public void addNewPane()
        {
            Panel lpanelToAdd = new Panel();
            lpanelToAdd.BackColor = Color.Bisque;
            AccordionPane lAccPaneToAdd = new AccordionPane();
            lAccPaneToAdd.HeaderContainer.Controls.Add(new LiteralControl(" Panel Ajouté"));
            lAccPaneToAdd.ContentContainer.Controls.Add(new LiteralControl("Contenu du Panel Ajouté."));
            lAccPaneToAdd.ContentContainer.Controls.Add(lpanelToAdd);
            this.Panes.Add(lAccPaneToAdd);
        }
    }
}
