﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using AjaxControlToolkit;

namespace AJAXCollapsePanelNameSpace
{
    [DefaultProperty("Text")]
    [ToolboxData("<{0}:WebCustomControlAjaxCollapsiblePanel runat=server></{0}:WebCustomControlAjaxCollapsiblePanel>")]
    public class WebCustomControlAjaxCollapsiblePanel : CollapsiblePanelExtender
    {
        const string DEFAULT_PATH = "C:\\Documents and Settings\\gourdet-j\\Bureau\\Site Apri en ligne\\APRI2.xml";

        TextBox _textBoxFichier;

        Label _hourLabel =new Label();

        public Button _confirmButton;

        public Button _autreButton;

        public AsyncPostBackTrigger _trigButton;

        public WebCustomControlAjaxCollapsiblePanel()
        {
            
            Panel lpanelHead = new Panel();
            lpanelHead.ID = "panelHeadAjaxCollapsible";
            lpanelHead.CssClass = "cpHeader";

            RoundedCornersExtender lroundedHead = new RoundedCornersExtender();
            lroundedHead.Radius = 12;
            lroundedHead.TargetControlID = lpanelHead.ID;
            lroundedHead.Corners = BoxCorners.BottomRight;
            
            Label lLabelHead = new Label();
            lLabelHead.ID = "labelHeadAjaxCollapsible";
            lpanelHead.Controls.Add(lLabelHead);

            //Creation du Panel de contenu
            Panel lpanelBody = new Panel();
            lpanelBody.ID = "panelBody";
            lpanelBody.CssClass = "cpBody";

            Label lLabelBody = new Label();
            lLabelBody.ID = "labelBody";
            lLabelBody.Text = "Ecrivez un emplacement de fichier";
            lpanelBody.Controls.Add(lLabelBody);

            // ajout d'un label pour le suivi des actions AJAX
            _hourLabel.Text = DateTime.Now.TimeOfDay.ToString();
            lpanelBody.Controls.Add(_hourLabel);

            _textBoxFichier = new TextBox();
            _textBoxFichier.Text = DEFAULT_PATH;
            lpanelBody.Controls.Add(_textBoxFichier);

            _confirmButton = new Button();
            _confirmButton.UseSubmitBehavior = false;
            _confirmButton.Text = "Charger";
            _confirmButton.ID = "lconfirmButtonID";
            _confirmButton.Click += new EventHandler(lconfirmButton_Click);
            this.Controls.Add(_confirmButton);
            lpanelBody.Controls.Add(_confirmButton);

            _trigButton = new AsyncPostBackTrigger();
            _trigButton.ControlID = _confirmButton.ID;
            _trigButton.EventName = "Click";
            // this.Events.AddHandler(lconfirmButton,confirmFileLoad);

            _autreButton = new Button();
            _autreButton.UseSubmitBehavior = false;
            _autreButton.Text = "Autre";
            _autreButton.ID = "lautreButtonID";
            _autreButton.Click += new EventHandler(lconfirmButton_Click);
            this.Controls.Add(_autreButton);
            lpanelBody.Controls.Add(_autreButton);

            this.Controls.Add(lpanelHead);
            this.Controls.Add(lpanelBody);
            // Initialisation du composant 

            this.ID = "WebCustomControlAjaxCollapsiblePanel";
            this.TargetControlID = lpanelBody.ID;
            this.ExpandControlID = lpanelHead.ID;
            this.CollapseControlID = lpanelHead.ID;
            this.ScrollContents = false;
            this.Collapsed = true;
            this.ExpandDirection =
            CollapsiblePanelExpandDirection.Vertical;
            this.SuppressPostBack = true;
            this.TextLabelID = lLabelHead.ID;
            this.CollapsedText = "Cliquer ici pour étendre..";
            this.ExpandedText = "Cliquer ici pour cacher..";

            
        }

        protected override void CreateChildControls()
        {
            this.ApplyStyleSheetSkin(this.Page);
            // Creation du Panel de titre
            base.CreateChildControls();
        }

        void lconfirmButton_Click(object sender, EventArgs e)
        {
            LoadPanel();
        }

        public void LoadPanel()
        {
            _hourLabel.Text = DateTime.Now.TimeOfDay.ToString();
          
            // Creation du Panel de représentation
           // Panel lpanelContainer = new Panel();
            //lpanelContainer.ID = "panelContainer";
            //lpanelContainer.CssClass = "cpBody";

            //Label lhourLabel = new Label();
            //lhourLabel.Text = DateTime.Now.TimeOfDay.ToString();

            //lpanelContainer.Controls.Add(lhourLabel);

            //this.Controls.Add(lpanelContainer);

        }

        protected void confirmFileLoad(object sender, EventArgs e)
        {
           
        }

        public void RegisterEvent(ScriptManager lScriptManager)
        {
            lScriptManager.RegisterAsyncPostBackControl(_confirmButton);

       //     lScriptManager.Page.AutoPostBackControl.Controls.Add(this._confirmButton);
        }

        #region ICallbackEventHandler Membres

        public string GetCallbackResult()
        {
            throw new NotImplementedException();
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
