﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using AjaxControlToolkit;

namespace AJAXCollapsible
{
    [DefaultProperty("Text")]
    [ToolboxData("<{0}:WebCustomControCollapsibleUpdatePanel runat=server></{0}:WebCustomControCollapsibleUpdatePanel>")]
    public class WebCustomControlCollapsibleUpdatePanel : UpdatePanel
    {
        const string DEFAULT_PATH = "C:\\Documents and Settings\\gourdet-j\\Bureau\\Site Apri en ligne\\APRI2.xml";

        TextBox _textBoxFichier;

        Label _hourCollapsibleLabel = new Label();

        public Button _confirmCollapsibleButton;

        public Button _autreCollapsibleButton;

        public AsyncPostBackTrigger _trigCollapsibleButton;

        protected CollapsiblePanelExtender _collapsiblePanel;

        public WebCustomControlCollapsibleUpdatePanel()
        {
            this.ID = "WebCustomControlCollapsibleUpdatePanel";
            this.UpdateMode = UpdatePanelUpdateMode.Conditional;
            this.ChildrenAsTriggers = true;
            _collapsiblePanel = new CollapsiblePanelExtender();
            //_collapsiblePanel.ApplyStyleSheetSkin(this.Page);


        }


        void lconfirmButton_Click(object sender, EventArgs e)
        {
            LoadPanel();
        }

        public void LoadPanel()
        {
            _hourCollapsibleLabel.Text = DateTime.Now.TimeOfDay.ToString();
            this.Update();
            // Creation du Panel de représentation
            // Panel lpanelContainer = new Panel();
            //lpanelContainer.ID = "panelContainer";
            //lpanelContainer.CssClass = "cpBody";

            //Label lhourLabel = new Label();
            //lhourLabel.Text = DateTime.Now.TimeOfDay.ToString();

            //lpanelContainer.Controls.Add(lhourLabel);

            //_collapsiblePanel.Controls.Add(lpanelContainer);

        }

        protected void confirmFileLoad(object sender, EventArgs e)
        {

        }

        public void RegisterEvent(ScriptManager lScriptManager)
        {
            lScriptManager.RegisterAsyncPostBackControl(_confirmCollapsibleButton);

            //     lScriptManager.Page.AutoPostBackControl.Controls.Add(_collapsiblePanel._confirmButton);
        }

        protected override void CreateChildControls()
        {
            base.CreateChildControls();
        }

        protected override void EnsureChildControls()
        {
            base.EnsureChildControls();
        }

        protected override Control CreateContentTemplateContainer()
        {
            return base.CreateContentTemplateContainer();
        }

        protected override void OnLoad(EventArgs e)
        {

            base.OnLoad(e);
        }

        protected override void LoadViewState(object savedState)
        {
            _autreCollapsibleButton.Click += new EventHandler(lconfirmButton_Click);
            _confirmCollapsibleButton.Click += new EventHandler(lconfirmButton_Click);
            // _confirmButton.OnClientClick = "LoadPanel()";

            _trigCollapsibleButton = new AsyncPostBackTrigger();
            _trigCollapsibleButton.ControlID = _confirmCollapsibleButton.ID;
            _trigCollapsibleButton.EventName = "Click";
            // _collapsiblePanel.Events.AddHandler(lconfirmButton,confirmFileLoad);
            this.Triggers.Add(_trigCollapsibleButton);

            base.LoadViewState(savedState);
        }


        protected override void OnInit(EventArgs e)
        {

            Panel lpanelHead = new Panel();
            lpanelHead.ID = "panelHeadAjaxCollapsible";
            lpanelHead.CssClass = "cpHeader";

            RoundedCornersExtender lroundedHead = new RoundedCornersExtender();
            lroundedHead.Radius = 12;
            lroundedHead.TargetControlID = lpanelHead.ID;
            lroundedHead.Corners = BoxCorners.BottomRight;
            lroundedHead.ApplyStyleSheetSkin(this.Page);

            Label lLabelHead = new Label();
            lLabelHead.ID = "labelHeadAjaxCollapsible";
            lpanelHead.Controls.Add(lLabelHead);

            //Creation du Panel de contenu
            Panel lpanelBody = new Panel();
            lpanelBody.ID = "panelBody";
            lpanelBody.CssClass = "cpBody";

            Label lLabelBody = new Label();
            lLabelBody.ID = "labelBody";
            lLabelBody.Text = "Ecrivez un emplacement de fichier";
            lpanelBody.Controls.Add(lLabelBody);

            // ajout d'un label pour le suivi des actions AJAX
            _hourCollapsibleLabel.Text = DateTime.Now.TimeOfDay.ToString();
            _hourCollapsibleLabel.ID = "myHourLabelCoolapsible";
            lpanelBody.Controls.Add(_hourCollapsibleLabel);

            _textBoxFichier = new TextBox();
            _textBoxFichier.Text = DEFAULT_PATH;
            lpanelBody.Controls.Add(_textBoxFichier);

            _confirmCollapsibleButton = new Button();
            _confirmCollapsibleButton.UseSubmitBehavior = false;
            _confirmCollapsibleButton.Text = "Charger";
            _confirmCollapsibleButton.ID = "lconfirmButtonID";
            lpanelBody.Controls.Add(_confirmCollapsibleButton);

            _trigCollapsibleButton = new AsyncPostBackTrigger();
            _trigCollapsibleButton.ControlID = _confirmCollapsibleButton.ID;
            _trigCollapsibleButton.EventName = "Click";
            // _collapsiblePanel.Events.AddHandler(lconfirmButton,confirmFileLoad);
            this.Triggers.Add(_trigCollapsibleButton);

            _autreCollapsibleButton = new Button();
            _autreCollapsibleButton.UseSubmitBehavior = false;
            _autreCollapsibleButton.Text = "Autre";
            _autreCollapsibleButton.ID = "lautreButtonID";

            _collapsiblePanel.Controls.Add(_autreCollapsibleButton);
            lpanelBody.Controls.Add(_autreCollapsibleButton);

            _collapsiblePanel.Controls.Add(lpanelHead);
            _collapsiblePanel.Controls.Add(lpanelBody);
            // Initialisation du composant 

            _collapsiblePanel.ID = "WebCustomControlAjaxCollapsiblePanel";
            _collapsiblePanel.TargetControlID = lpanelBody.ID;
            _collapsiblePanel.ExpandControlID = lpanelHead.ID;
            _collapsiblePanel.CollapseControlID = lpanelHead.ID;
            _collapsiblePanel.ScrollContents = false;
            _collapsiblePanel.Collapsed = true;
            _collapsiblePanel.ExpandDirection = CollapsiblePanelExpandDirection.Vertical;
            // _collapsiblePanel.SuppressPostBack = true;
            _collapsiblePanel.TextLabelID = lLabelHead.ID;
            _collapsiblePanel.CollapsedText = "Cliquer ici pour étendre..";
            _collapsiblePanel.ExpandedText = "Cliquer ici pour cacher..";

            //Ajout du collapsible à l'update Panel du controle.
            this.ContentTemplateContainer.Controls.Add(_collapsiblePanel);

            base.OnInit(e);
        }
    }
}
