﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using AJAXAccordeon;
using System.Drawing;
using AjaxControlToolkit;
using AJAXCollapsePanelNameSpace;
using AJAXCollapsible;
using UIComponents;

namespace AJAXComposant
{
    public partial class _Default : System.Web.UI.Page
    {
        public const string CSS_AJAX_COMPOSANT = "AjaxComposant.css";

        WebCustomControlAjaxAccordeon _AjaxAccordeon;

        WebUserControlCollapsible _Collapsible;

        WebCustomControlAjaxCollapsiblePanel _AjaxCollapsible;

        AsyncPostBackTrigger _trigButtonAjaxCollapsible;

        AjaxCollapsibleWebPart webPart = new AjaxCollapsibleWebPart();

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!this.IsPostBack)
            {
                _trigButtonAjaxCollapsible = new AsyncPostBackTrigger();

                this.LabelMasterHour.Text = DateTime.Now.TimeOfDay.ToString();
                _Collapsible = new WebUserControlCollapsible();
                //   _trigButtonAjaxCollapsible = new AsyncPostBackTrigger();
                // _trigButtonAjaxCollapsible.EventName = "Click";
                //   this.UpdatePanel4.Triggers.Add(_trigButtonAjaxCollapsible);

            }
        }

        protected override void CreateChildControls()
        {
            base.CreateChildControls();
            if (this.asm.IsInAsyncPostBack)
            {
                string fromWhere = Request[this.asm.ID];
                Label1.Text = fromWhere;
            }

        }

        protected void _dependantAccordeon_Click(object sender, EventArgs e)
        {
            //L'ajout dynamique se déroule correctement mais le composant est déjà embarqué dans le code design.
            this.WebUserControlDependant1.AddPane();
          
        }

        protected void _ajaxAccordeon_Click(object sender, EventArgs e)
        {
            //Création dynamique fonctionne mais 
            _AjaxAccordeon = new WebCustomControlAjaxAccordeon();
            this.UpdatePanel2.ContentTemplateContainer.Controls.Add(this._AjaxAccordeon);

        }

        protected void _dependantCollapsible_Click(object sender, EventArgs e)
        {
            // Create Header Panel
            Panel lpanelHead = new Panel();
            lpanelHead.ID = "panelHead";
            lpanelHead.BackColor = Color.Purple;
            // Add Label inside header panel to display text
            Label lLabelHead = new Label();
            lLabelHead.ID = "labelHeader";
            lpanelHead.Controls.Add(lLabelHead);

            //Creation du Panel 
            Panel lpanelBody = new Panel();
            lpanelBody.ID = "panelBody";
            lpanelBody.CssClass = "cpBody";
            // Add Label inside body Panel to display text
            Label lLabelBody = new Label();
            lLabelBody.ID = "lblBody";
            lLabelBody.Text = "Panel ajouté dynamiquement";
            lpanelBody.Controls.Add(lLabelBody);

            // Create CollapsiblePanelExtender
            CollapsiblePanelExtender lcollapsible =
                new CollapsiblePanelExtender();
            lcollapsible.TargetControlID = lpanelBody.ID;
            lcollapsible.ExpandControlID = lpanelHead.ID;
            lcollapsible.CollapseControlID = lpanelHead.ID;
            lcollapsible.ScrollContents = false;
            lcollapsible.Collapsed = true;
            lcollapsible.ExpandDirection =
            CollapsiblePanelExpandDirection.Vertical;
            lcollapsible.SuppressPostBack = true;
            lcollapsible.TextLabelID = lLabelHead.ID;
            lcollapsible.CollapsedText = "Cliquer ici pour étendre..";
            lcollapsible.ExpandedText = "Cliquer ici pour cacher..";

            this.UpdatePanel3.ContentTemplateContainer.Controls.Add(lpanelHead);
            this.UpdatePanel3.ContentTemplateContainer.Controls.Add(lpanelBody);
            this.UpdatePanel3.ContentTemplateContainer.Controls.Add(lcollapsible);
            this.UpdatePanel3.Update();
        }

        protected void _ajaxCollapsible_Click(object sender, EventArgs e)
        {

            _AjaxCollapsible = new WebCustomControlAjaxCollapsiblePanel();
            this.Controls.Add(_AjaxCollapsible);
            //_trigButtonAjaxCollapsible.ControlID = "lconfirmButtonID";

            //Création du Bouton de test 
            Button _pageButton = new Button();
            _pageButton.UseSubmitBehavior = false;
            _pageButton.ID = "lPanelButtonID";
            _pageButton.Text = "updatePanelPageButton";
            _pageButton.Click += new EventHandler(_pageButton_Click);
            this.UpdatePanel4.ContentTemplateContainer.Controls.Add(_pageButton);
            this.asm.RegisterAsyncPostBackControl(_pageButton);
            //Création du trigger de test 
            AsyncPostBackTrigger _trigger = new AsyncPostBackTrigger();
            _trigger.ControlID = _pageButton.ID;
            //_trigger.EventName ="Click"
            this.UpdatePanel4.Triggers.Add(_trigger);
            this.UpdatePanel4.ContentTemplateContainer.Controls.Add(_AjaxCollapsible);
            //this.UpdatePanel4.Update();
            this.EnsureID();
            _AjaxCollapsible.RegisterEvent(this.asm);
            this.UpdatePanel4.Triggers.Add(_AjaxCollapsible._trigButton);
            // this.asm.RegisterAsyncPostBackControl(_AjaxCollapsible._trigButton);
            this.UpdatePanel4.Visible = true;
        }

        void _pageButton_Click(object sender, EventArgs e)
        {
            _AjaxCollapsible.LoadPanel();
        }

        protected override void OnInit(EventArgs e)
        {
            AddStylesheet(this, CSS_AJAX_COMPOSANT);
            base.OnInit(e);
            this.asm.EnablePartialRendering = true;
            this.asm.EnablePageMethods = true;
            this.UpdatePanel4.ChildrenAsTriggers = true;
            this.UpdatePanel4.UpdateMode = UpdatePanelUpdateMode.Conditional;
        }

        private void AddStylesheet(Control aControl, string aStyleSheetRessourceName)
        {
            LiteralControl include = null;
            // TODO : mettre en place une fonction plus avancée pour éviter l'ajout d'une même feuille plusieurs fois
            string includeTemplate = "<link rel='stylesheet' text='text/css' href='{0}' />";

            // récupération du lien "client"

            string includeLocation = aControl.Page.ClientScript.GetWebResourceUrl(aControl.GetType(), aStyleSheetRessourceName);
            string lInclude = String.Format(includeTemplate, includeLocation);
            // création d'un contrôle 
            if ((aControl != null) && (aControl.Page != null) && (aControl.Page.Header != null))

                include = new LiteralControl(String.Format(includeTemplate, includeLocation));
            // ajout du contrôle au header
            ((System.Web.UI.HtmlControls.HtmlHead)aControl.Page.Header).Controls.Add(include);
        }

        protected void Button1_Click(object sender, EventArgs e)
        {


        }

        protected void ButtonLoadPanel_Click(object sender, EventArgs e)
        {
            // this.UpdatePanel4.Update();

        }

        protected void ButtonUpdatePanel_Click(object sender, EventArgs e)
        {
            WebCustomControlCollapsibleUpdatePanel lajaxUpdatePanel = new WebCustomControlCollapsibleUpdatePanel();

            //Création du Bouton de test 
            Button _dynamicButton = new Button();
            // _dynamicButton.UseSubmitBehavior = false;
            _dynamicButton.ID = "lDynamicButtonID";
            _dynamicButton.Text = "DynamicPageButton";
            _dynamicButton.Click += new EventHandler(_pageButton_Click);
            lajaxUpdatePanel.ContentTemplateContainer.Controls.Add(_dynamicButton);
            this.asm.RegisterAsyncPostBackControl(_dynamicButton);
            //Création du trigger de test 
            AsyncPostBackTrigger _dynamicTrigger = new AsyncPostBackTrigger();
            _dynamicTrigger.ControlID = _dynamicButton.ID;
            //_trigger.EventName ="Click"
            lajaxUpdatePanel.Triggers.Add(_dynamicTrigger);

            // this.Page.Form.Controls.Add(lajaxUpdatePanel);
            this.Controls.Add(lajaxUpdatePanel);
            this.asm.TemplateControl.Controls.Add(lajaxUpdatePanel);
            //this.asm.Controls.Add(lajaxUpdatePanel);
            lajaxUpdatePanel.RegisterEvent(this.asm);
            //this.asm.RegisterAsyncPostBackControl(lajaxUpdatePanel);

        }

        protected void ButtonWebPart_Click(object sender, EventArgs e)
        {

            this.PlaceHolderAjax.Controls.Add(webPart);
            //Controls.Add(webPart);
            this.asm.RegisterAsyncPostBackControl(webPart);

            //AsyncPostBackTrigger _dynamicTrigger = new AsyncPostBackTrigger();
            //_dynamicTrigger.ControlID = webPart._hourButton.ID;
            //this.EnsureID();
            ////_trigger.EventName ="Click"
            //this.UpdatePanel4.Triggers.Add(_dynamicTrigger);

        }

        protected void _refreshWebPart_Click(object sender, EventArgs e)
        {
            webPart.RefreshHour();
        }


    }
}
